import { world, system, EquipmentSlot} from "@minecraft/server";
import { launchPlayer } from "./../../util/movements.js";
import { weaponDamageIndicator, generateUniqueId, stunDamageIndicator } from "./../../util/utils.js";
import { attackPlayerMeikyu, executer } from "./../../util/attackMethods.js";

const animations =[ 
    [
        {
            animation: "minced.spear.attack_sprint",
            knockback: [1,0],
            Player_Knockback: [2,0.2],
            type: "slash",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 10,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.spear.attack0",
            knockback: [0.5,0],
            Player_Knockback: [1,0],
            type: "slash",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 1.5,
            targetNum: 10,
            damage_multiplier: 1.5,
            stun_damage_multiplier: 0.45,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.spear.attack1",
            knockback: [0.25,0.25],
            Player_Knockback: [3,0],
            type: "pierce",
            attack_speed: 12,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 2,
            targetNum: 3,
            damage_multiplier: 1.25,
            stun_damage_multiplier: 0.75,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.spear.attack2",
            knockback: [1,0],
            Player_Knockback: [2,0],
            type: "slash",
            attack_speed: 8,
            hit_number: 2,
            stun_type: "short",
            range: 3,
            distance: 1,
            targetNum: 6,
            damage_multiplier: 0.75,
            stun_damage_multiplier: 0.5,
            next_attack_time: 5,
            Unbreakable: false
        }
    ]
]

const offhand =[ 
    [
        {
            animation: "minced.spear.attack_sprint",
            knockback: [1,0],
            Player_Knockback: [2,0.2],
            type: "slash",
            attack_speed: 8,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 2,
            targetNum: 10,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.spear.attack_offhand",
            knockback: [0.5,0],
            Player_Knockback: [1,0],
            type: "pierce",
            attack_speed: 9,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 2,
            targetNum: 10,
            damage_multiplier: 1,
            stun_damage_multiplier: 1,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.spear.attack_offhand2",
            knockback: [0.5,0],
            Player_Knockback: [1.5,0],
            type: "slash",
            attack_speed: 18,
            hit_number: 1,
            stun_type: "medium",
            range: 3,
            distance: 1,
            targetNum: 3,
            damage_multiplier: 1.5,
            stun_damage_multiplier: 1,
            next_attack_time: 5,
            Unbreakable: false
        },
        {
            animation: "minced.spear.attack_offhand3",
            knockback: [0.5,0],
            Player_Knockback: [1,0],
            type: "pierce",
            attack_speed: 9,
            hit_number: 1,
            stun_type: "short",
            range: 3,
            distance: 2,
            targetNum: 6,
            damage_multiplier: 0.75,
            stun_damage_multiplier: 1,
            next_attack_time: 5,
            Unbreakable: false
        }
    ]
]


const weapon = {
    name: 'spear',
    display_name: "Spear",
    dual_wield: ["spear","dagger","halberd","lance","shield"],
    type: "polearm",
    can_block: false,
    block_damage: 25,
    block_power: 20,
    block_time: 6,
    clash_power: 30,
    front_dodge: [3, 0.25],
    back_dodge:[-3, 0.25],
    left_dodge:"none",
    right_dodge:"none",
    stylePrefixes: ["minced.spear"],
    weaponSize: "small",
    cd: 20,
    available_moves: [],
    execute(player, weapon, effect, mode, burn) {
        const cd = this.cd
        const blckdmg = this.block_damage
        let atkspd
        let lavander = weaponDamageIndicator(weapon)
        let stundamage = stunDamageIndicator(weapon.getTags())
        let critChance = Math.floor(Math.random()*9)
        let critDamage = 0
        critChance == 2 ? critDamage = Math.floor(Math.random() * lavander) : critDamage = 0
        lavander = JSON.parse(lavander) + critDamage
        const { x, z } = player.getVelocity();
        const speed = (Math.sqrt(x ** 2 +  z ** 2) * 20).toFixed(1);
        let animChecker
        for(let i = animations[0].length - 1; i > 0; i--) {
            if(player.getDynamicProperty("combo") % i == 0) {
                animChecker = i
                break;
            }
        }
        
        let attackEffect = []
        attackEffect.push(effect)
        if(weapon.getComponent("minecraft:enchantable").hasEnchantment("fire_aspect")) {
            attackEffect.push("flames")
        }
        switch(mode) {
            case "sprint":{
                let propCheck = animations[0][0]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                if(animChecker == 3) {
                    player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                }
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, true)
            } break;
            case "jump": {
                let propCheck = {
                    animation: "minced.spear.attack_jump",
                    knockback: [2,0],
                    Player_Knockback: [2,0],
                    type: "slash",
                    attack_speed: 8,
                    hit_number: 1,
                    stun_type: "medium",
                    range: 3,
                    distance: 0,
                    targetNum: 3,
                    damage_multiplier: 1.5,
                    stun_damage_multiplier: 1,
                    next_attack_time: 15,
                    Unbreakable: false
                }
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                if(animChecker == 3) {
                    player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                }
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown", weapon, hitCount, true)
            } break; 
            case "offhand_shield":{
                let propCheck = offhand[0][animChecker]
                let knockback = propCheck.knockback
                let Player_Knockback = propCheck.Player_Knockback
                system.runTimeout(() => {
                    launchPlayer(player, Player_Knockback[0], Player_Knockback[1])
                },3)
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, offhand[0].length - 1, stunD, NAT, breakable, "normal",weapon, hitCount, true)
            } break;
            case "execute": {
                executer(player, burn, (lavander * 200), this.name, 44)
            } break;
            default: {
                let propCheck = animations[0][animChecker]
                let knockback = propCheck.knockback
                player.playAnimation(`animation.${propCheck.animation}`)
                atkspd = propCheck.attack_speed
                let Pknockback = propCheck.Player_Knockback 
                let effects = propCheck.type
                let stun = propCheck.stun_type
                let ranger = propCheck.range
                let distil = propCheck.distance
                let tgtnm = propCheck.targetNum
                let NAT = propCheck.next_attack_time
                let stunD = stundamage * propCheck.stun_damage_multiplier
                let breakable = propCheck.Unbreakable
                let hitCount = propCheck.hit_number
                system.runTimeout(()=>{
                    launchPlayer(player, Pknockback[0], Pknockback[1])
                },atkspd)
                if(animChecker == 3) {
                    player.addEffect("slow_falling", 16, { amplifier: 3, showParticles: false })
                }
                attackPlayerMeikyu(player, ranger, (lavander * propCheck.damage_multiplier), blckdmg, cd, atkspd, distil, tgtnm, "line_target", attackEffect, knockback, stun, "", effects, (animations[0].length - 1), stunD, NAT, breakable, "no cooldown",weapon, hitCount, true)
            }
            break;
        }
    },
    setCore(player, item) {
        let Abilities = [
            {
              Id: "S1",
            },
            {
              Id: "P3",
            },
            {
              Id: "T1",
            },
            {
              Id: "T2",
            },
            {
              Id: "O0",
            }
          ]
          item.setDynamicProperty("abilities", JSON.stringify(Abilities))
          item.setDynamicProperty("fightStyle", 1)
        player.getComponent('equippable')?.setEquipment(EquipmentSlot.Mainhand, item)
    },
    getCurrentAtkspd(player) {
        let animChecker
        for(let i = (animations[0].length - 1); i > 0; i--) {
            if(player.getDynamicProperty("combo") % i == 0) {
                animChecker = i
                break;
            }
        }
        return animations[0][animChecker].attack_speed
    } 
}

export default weapon


